/***************************************************************************
    QuotedPrintable - Decodes quoted printable text portions

    author:  Ulrich Krebs
    email :  ukrebs@freenet.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

class QuotedPrintable
{
	static String decode(String text)
	{
		StringBuffer out=new StringBuffer();
		
		int startIndex=0;
		int endIndex=0;
		
		while((endIndex=text.indexOf('=',startIndex))>=0)
		{
			if(text.length()>endIndex+2)
			{
				String isoChar=text.substring(endIndex+1,endIndex+3);
				try
				{
					char c=(char)(Integer.valueOf(isoChar,16).intValue());
					out.append(text.substring(startIndex,endIndex));
					out.append(c);
					startIndex=endIndex+3;
				}
				catch(NumberFormatException e)
				{
					out.append(text.substring(startIndex,endIndex));
					startIndex=endIndex+3;					
				}
			}
			else
			{
				out.append(text.substring(startIndex,endIndex));
				startIndex=endIndex+1;
			}
		}
		out.append(text.substring(startIndex));

		return out.toString();
	}
}
